<?php

declare(strict_types=1);

namespace App\Policies;

use Illuminate\Foundation\Auth\User as AuthUser;
use App\Models\CreditCoupon;
use Illuminate\Auth\Access\HandlesAuthorization;

class CreditCouponPolicy
{
    use HandlesAuthorization;
    
    public function viewAny(AuthUser $authUser): bool
    {
        return $authUser->can('ViewAny:CreditCoupon');
    }

    public function view(AuthUser $authUser, CreditCoupon $creditCoupon): bool
    {
        return $authUser->can('View:CreditCoupon');
    }

    public function create(AuthUser $authUser): bool
    {
        return $authUser->can('Create:CreditCoupon');
    }

    public function update(AuthUser $authUser, CreditCoupon $creditCoupon): bool
    {
        return $authUser->can('Update:CreditCoupon');
    }

    public function delete(AuthUser $authUser, CreditCoupon $creditCoupon): bool
    {
        return $authUser->can('Delete:CreditCoupon');
    }

    public function restore(AuthUser $authUser, CreditCoupon $creditCoupon): bool
    {
        return $authUser->can('Restore:CreditCoupon');
    }

    public function forceDelete(AuthUser $authUser, CreditCoupon $creditCoupon): bool
    {
        return $authUser->can('ForceDelete:CreditCoupon');
    }

    public function forceDeleteAny(AuthUser $authUser): bool
    {
        return $authUser->can('ForceDeleteAny:CreditCoupon');
    }

    public function restoreAny(AuthUser $authUser): bool
    {
        return $authUser->can('RestoreAny:CreditCoupon');
    }

    public function replicate(AuthUser $authUser, CreditCoupon $creditCoupon): bool
    {
        return $authUser->can('Replicate:CreditCoupon');
    }

    public function reorder(AuthUser $authUser): bool
    {
        return $authUser->can('Reorder:CreditCoupon');
    }

}